import i18n from '../../locales/index';
import { useBasicStore } from '../../stores/basic';

export const setLanguage = (language: string) => {
  const basicStore = useBasicStore(); // pina 使用需要 app.use(pinia) 之后，这里的执行顺序更靠前
  switch (language) {
    case 'en':
      i18n.global.locale.value = 'zh-CN';
      basicStore.setLang('zh-CN');
      localStorage.setItem('tuiRoom-language', 'zh-CN');
      break;
    case 'zh':
      i18n.global.locale.value = 'en-US';
      basicStore.setLang('en-US');
      localStorage.setItem('tuiRoom-language', 'en-US');
      break;
    default:
      return;
  }
};
